# Dumping IS-NITRO-EMULATOR DS BIOS and Firmware

## What you need
- A IS-NITRO-EMULATOR
- A Windows environment with the IS-NITRO-DEBUGGER software installed
- [dsbf_dump v1.3.0](https://github.com/DS-Homebrew/dsbf_dump/releases/download/v1.3.0/dsbf_dump.nds)

## Section I - Loading the dumper ROM
1. Rename the `dsbf_dump.nds` you downloaded to `dsbf_dump.srl`.
2. Connect the IS-NITRO-EMULATOR to Windows via USB and launch the IS-NITRO-DEBUGGER software.
3. Go to `File` > `Load File`.

![](https://cdn.randommeaninglesscharacters.com/dump_is_nitro/1.png)

4. Select `SRL` under `Open File`, click `Browse` and choose `dsbf_dump.srl`. Tick all 3 boxes, then press `OK`.

![](https://cdn.randommeaninglesscharacters.com/dump_is_nitro/2.png)

5. Wait for the progress bars to complete. The DS should reboot into dsbf_dump.

## Section II - Dumping debugger memory
1. On the DS, press (A) on `Please press the A button to continue as a dev-kit.`.
2. Wait till the screen shows `buffer at: 0x2xxxxxx`. Note down the hexadecimal address.
3. Press the pause button in the debugger toolbar.

![](https://cdn.randommeaninglesscharacters.com/dump_is_nitro/3.png)

4. Go to `File` > `Save File`.
    - Click `Browse` and name the file `fw.bin`
    - Select `ARM9` under `Source Memory Area`
    - In `Start Address` key in the address you noted down in step 2
    - For `Length` key in `0x100000`

    Then press `OK`.

![](https://cdn.randommeaninglesscharacters.com/dump_is_nitro/4.png)

5. Once the progress bar completes, press the soft run button in the debugger toolbar.

![](https://cdn.randommeaninglesscharacters.com/dump_is_nitro/5.png)

6. On the DS, press (Start), and repeat steps 2 to 5, but name the file `bios7.bin` instead.
7. On the DS, press (Start), and repeat steps 2 to 5, but name the file `bios9.bin` instead.
8. On the DS, press (Start) twice to exit. You can press `OK` to the message on the debugger saying `It is going to recover NITRO processor`.

## Section III - Trimming dumps

### Windows
*The following instructions use the HxD hex editor, but other hex editors can be used as well.*
1. Launch the HxD hex editor and open `fw.bin`.
2. Select the first 0x100 bytes of `DE`, right click > `Delete`. Press `OK` to `Do you want to proceed?`.

![](https://cdn.randommeaninglesscharacters.com/dump_is_nitro/6.png)

3. Scroll down to 0x40000, right click > `Select block`.
    - In `Start-offset` key in `40000`
    - In `End-offset` key in `100000`
    - Choose `hex`
    
    Then press `OK`.
4. Right click the selected region > `Delete`, and press `OK` to `Do you want to proceed?`. Save the file.
5. Repeat steps 1 to 4 for `bios7.bin`, but for `Start-offset` key in `4000` instead.
6. Repeat steps 1 to 4 for `bios9.bin`, but for `Start-offset` key in `1000` instead.
7. Copy `fw.bin`, `bios7.bin` and `bios9.bin` to a safe location on your computer.

### Linux / macOS
1. Open a terminal in the folder containing the 3 `.bin` files, and run the following commands:
```
mkdir out/
dd if=fw.bin of=out/fw.bin bs=1 skip=0x100 count=0x40000
dd if=bios7.bin of=out/bios7.bin bs=1 skip=0x100 count=0x4000
dd if=bios9.bin of=out/bios9.bin bs=1 skip=0x100 count=0x1000
```
2. Go inside the `out` folder, and copy `fw.bin`, `bios7.bin` and `bios9.bin` to a safe location on your computer.